# -*- coding: utf-8 -*-

import numpy as np
from sympy.combinatorics.graycode import GrayCode
import NKPackage_e as nkp


def get_I(N, K, TYPE):
    matrix = nkp.interaction_matrix(N, K, type=TYPE)
    matrix = np.nonzero(matrix)[1].reshape(N, K+1)
    return matrix


def f(j, s, deps_j, f_dict_j):
    sub_s = tuple(s[deps_j])
    if sub_s not in f_dict_j:
        f_dict_j[sub_s] = np.random.rand()
    return f_dict_j[sub_s]


def get_F(N, K, deps, gray_code):
    fs = [{} for _ in range(N)]
    F = {tuple(gray_code[i]):
         sum([f(j, gray_code[i], deps[j], fs[j]) for j in range(N)]) / N
         for i in range(len(gray_code))}
    return F, fs


def get_Fs(M, N, K, TYPE):
    gray_code = np.array([list(map(int, s))
                          for s in GrayCode(N).generate_gray()])
    i_mat = get_I(N, K, TYPE)
    Fs = [get_F(N, K, i_mat, gray_code) for i in range(M)]
    return Fs[0], i_mat
