# -*- coding: utf-8 -*-
"""
Created on Mon Nov 28 16:27:04 2022

@author: user
"""

import numpy as np
import landscape_generator_e as lg
import itertools
from matplotlib import pyplot as plt
import matplotlib.style as style
import random as rd
from tqdm import tqdm
from scipy.stats import truncnorm
import os
import NKPackage_e as nkp

N = 12
K = 5
M = 30
ALPHA = 0.5
BETA = 0.5
TAU = [0, 10, 1]
P = 1
Q = 1
COORD = "lateral"
PROP = 2
COMP = 2
delta = 1
L1 = [0, 1, 2, 3]
L2 = [4, 5, 6, 7]
L3 = [8, 9, 10, 11]
T = 100
MC = 1500
TYPE = "dependent"

# 1. INITIALIZATION

def get_decisions():
    d = np.array(list(itertools.product((0, 1), repeat=N)))[np.random.choice(
        2**N, 1)][0]
    d_list = list(d)
    d_L1 = [tuple(d_list[:4])]
    d_L2 = [tuple(d_list[4:8])]
    d_L3 = [tuple(d_list[8:12])]
    valid_comb_4 = comb_4.copy()
    return d, d_L1, d_L2, d_L3, valid_comb_4
# This function determines the set of valid initial decisions at t = 0

def assign_groups(valid_comb_4):
    group_count_1 = 0
    group_count_2 = 0
    group_count_3 = 0
    my_agents = {}
    for i in range(M):
        random = np.random.rand()
        if random <= 1/3:
            index = np.random.randint(len(valid_comb_4))
            index_0 = [np.array(valid_comb_4)[index]]
            number=2**(len(L1))
            beliefs_p=[[1,1]]*number
            beliefs_q=[[1,1]]*number
            time = [0]*number
            my_agents[i] = [L1, index_0,beliefs_p, beliefs_q, time]
            group_count_1 += 1
        elif 1/3 < random <= 2/3:
            index = np.random.randint(len(valid_comb_4))
            index_0 = [np.array(valid_comb_4)[index]]
            number=2**(len(L1))
            beliefs_p=[[1,1]]*number
            beliefs_q=[[1,1]]*number
            time = [0]*number
            my_agents[i] = [L2, index_0,beliefs_p, beliefs_q, time]
            group_count_2 += 1
        elif random > 2/3:
            index = np.random.randint(len(valid_comb_4))
            index_0 = [np.array(valid_comb_4)[index]]
            number=2**(len(L1))
            beliefs_p=[[1,1]]*number
            beliefs_q=[[1,1]]*number
            time = [0]*number
            my_agents[i] = [L3, index_0,beliefs_p, beliefs_q, time]
            group_count_3 += 1
    return group_count_1, group_count_2, group_count_3, my_agents
# This function assigns a random decision to each agent.

# 2. TEAM FORMATION

def get_coalition(F, fs, i_mat, d, agents):
    e_ut_list = []
    for agent, value in agents.items():
        exp_utility = []
        for i in range(len(value[1])):
            comb = value[1][i]
            new_d = d.copy()
            new_d[value[0]] = comb
            iep_alpha = ALPHA*sum(
                    [fs[f][tuple(new_d[
                            i_mat[f]])] for f in value[0]]) / len(value[0])
            iep_beta = BETA * F[tuple(new_d)]
            i_ep_good = iep_alpha + iep_beta
            error = np.random.normal(loc=0.0, scale=0.1, size=None)*i_ep_good
            while error > 0.1 or error < -0.1:
                    error = np.random.normal(loc=0.0, scale=0.1, size=None)*i_ep_good
            i_ep = i_ep_good + error
            exp_utility.append(i_ep)
        e_comb_index = np.argmax(exp_utility)
        e_ut_list.append(exp_utility[e_comb_index])
    max_L1_ag, max_L1_eut = [], []
    max_L2_ag, max_L2_eut = [], []
    max_L3_ag, max_L3_eut = [], []
    for agent, value in agents.items():
        if value[0] == L1:
            max_L1_ag.append(agent)
            max_L1_eut.append(e_ut_list[agent])
        elif value[0] == L2:
            max_L2_ag.append(agent)
            max_L2_eut.append(e_ut_list[agent])
        else:
            max_L3_ag.append(agent)
            max_L3_eut.append(e_ut_list[agent])
    agent_1 = max_L1_ag[np.random.choice(np.argwhere(
            max_L1_eut == np.amax(max_L1_eut)).flatten())]
    agent_2 = max_L2_ag[np.random.choice(np.argwhere(
            max_L2_eut == np.amax(max_L2_eut)).flatten())]
    agent_3 = max_L3_ag[np.random.choice(np.argwhere(
            max_L3_eut == np.amax(max_L3_eut)).flatten())]
    return agent_1, agent_2, agent_3
# This function determined the bids of each agent and the ones that will form
# the team

# 3. DECISION-MAKING

def get_strategy(group_winners, agents, d, ALPHA, BETA, fs, i_mat, F, COORD, utility_T,t):
    if COORD == "decentral":
        comb_list = []
        for i,j in enumerate(group_winners):
            value = agents[j]
            utility = []
            for comb in value[1]:
                exp_d = d.copy()
                exp_d[value[0]] = comb
                iep_alpha = ALPHA*sum(
                        [fs[f][tuple(exp_d[
                                i_mat[f]])] for f in value[0]]) / len(value[0])
                iep_beta = BETA * F[tuple(exp_d)]
                i_ep_good = iep_alpha + iep_beta
                error = np.random.normal(loc=0.0, scale=0.1, size=None)*i_ep_good
                while error > 0.1 or error < -0.1:
                    error = np.random.normal(loc=0.0, scale=0.1, size=None)*i_ep_good
                i_ep = i_ep_good + error
                utility.append(i_ep)
            ut = utility_T[t-1][i]
            max_ut = max(utility)
            if max_ut > ut:
                comb_index = np.argmax(utility)
                best_comb = value[1][comb_index]
                comb_list.append([best_comb, value[0]])
        for comb in comb_list:
            d[comb[1]] = comb[0]
        return d
    if COORD == "sequential":
        comb_list = []
        for i,j in enumerate(group_winners):
            value = agents[j]
            utility = []
            for comb in value[1]:
                exp_d = d.copy()
                exp_d[value[0]] = comb
                iep_alpha = ALPHA*sum(
                        [fs[f][tuple(exp_d[
                                i_mat[f]])] for f in value[0]]) / len(value[0])
                iep_beta = BETA * F[tuple(exp_d)]
                i_ep_good = iep_alpha + iep_beta
                error = np.random.normal(loc=0.0, scale=0.1, size=None)*i_ep_good
                while error > 0.1 or error < -0.1:
                    error = np.random.normal(loc=0.0, scale=0.1, size=None)*i_ep_good
                i_ep = i_ep_good + error
                utility.append(i_ep)
            ut = utility_T[t-1][i]
            max_ut = max(utility)
            if max_ut > ut:
                comb_index = np.argmax(utility)
                best_comb = value[1][comb_index]
                d[value[0]] = best_comb
        return d
    if COORD == "hierarchy":
        comb_list = []
        for group_winner in group_winners:
            value = agents[group_winner]
            utility = []
            for comb in value[1]:
                exp_d = d.copy()
                exp_d[value[0]] = comb
                iep_alpha = ALPHA*sum(
                        [fs[f][tuple(exp_d[
                                i_mat[f]])] for f in value[0]]) / len(value[0])
                iep_beta = BETA * F[tuple(exp_d)]
                i_ep_good = iep_alpha + iep_beta
                error = np.random.normal(loc=0.0, scale=0.1, size=None)*i_ep_good
                while error > 0.1 or error < -0.1:
                    error = np.random.normal(loc=0.0, scale=0.1, size=None)*i_ep_good
                i_ep = i_ep_good + error
                utility.append(i_ep)
            top_combs_index = np.argsort(utility)[::-1][0:PROP]
            top_combs = [value[1][i] for i in top_combs_index]
            comb_list.append([top_combs, value[0]])
        d_candidates = [np.zeros(N,dtype=int)]*COMP
        for i,d_cand in enumerate(d_candidates):
            for comb in comb_list:
                PROPval = np.min([PROP,len(comb[0])])
                d_cand[comb[1]] = comb[0][np.random.randint(PROPval)]
            d_candidates[i] = d_cand
        perf_candidates = [F[tuple(i)] for i in d_candidates]
        if np.max(perf_candidates)>F[tuple(d)]:
            d = d_candidates[np.argmax(perf_candidates)]
        return d
    if COORD == "liaison":
        comb_list = []
        for group_winner in group_winners:
            value = agents[group_winner]
            utility = []
            for comb in value[1]:
                    exp_d = d.copy()
                    exp_d[value[0]] = comb
                    iep_alpha = ALPHA*sum(
                        [fs[f][tuple(exp_d[
                                i_mat[f]])] for f in value[0]]) / len(value[0])
                    iep_beta = BETA * F[tuple(exp_d)]
                    i_ep_good = iep_alpha + iep_beta
                    error = np.random.normal(loc=0.0, scale=0.1, size=None)*i_ep_good
                    while error > 0.1 or error < -0.1:
                        error = np.random.normal(loc=0.0, scale=0.1, size=None)*i_ep_good
                    i_ep = i_ep_good + error
                    utility.append(i_ep)
            top_combs_index = np.argsort(utility)[::-1][0:PROP]
            top_combs = [value[1][i] for i in top_combs_index]
            comb_list.append([top_combs, value[0]])
        comblen = [len(z[0]) for z in comb_list]
        PROPval = np.min([PROP,min(comblen)])
        d_candidates = list(np.zeros((PROPval,N),dtype=int))
        for i,d_cand in enumerate(d_candidates):
            for comb in comb_list:
                d_cand[comb[1]] = comb[0][i]
        votes = []
        for group_winner in group_winners:
            value = agents[group_winner]
            vote = []
            utility = []
            u_alpha = ALPHA*sum([fs[f][tuple(d[
                                i_mat[f]])] for f in value[0]]) / len(value[0])
            u_beta = BETA * F[tuple(d)]
            u = u_alpha + u_beta
            for d_cand in d_candidates:
                iep_alpha = ALPHA*sum(
                        [fs[f][tuple(exp_d[
                                i_mat[f]])] for f in value[0]]) / len(value[0])
                iep_beta = BETA * F[tuple(exp_d)]
                i_ep_good = iep_alpha + iep_beta
                error = np.random.normal(loc=0.0, scale=0.1, size=None)*i_ep_good
                while error > 0.1 or error < -0.1:
                    error = np.random.normal(loc=0.0, scale=0.1, size=None)*i_ep_good
                i_ep = i_ep_good + error
                utility.append(i_ep)
            for ut in utility:
                 if ut > u:
                     vote.append(1)
                 else:
                     vote.append (0)
            votes.append(vote)
        votes_a = [item[0] for item in votes]
        if len(votes[0]) == 2:
            votes_b = [item[1] for item in votes]
            votes = [votes_a,votes_b]
        else:
            votes = [votes_a]
        for i,v in enumerate(votes):
            if sum(v)==3:
                d = d_candidates[i]
                break
        return d
    if COORD == "lateral":
        comb_list = []
        for group_winner in group_winners:
            value = agents[group_winner]
            PROPval = np.min([PROP,len(value[1])])
            index = np.random.randint(PROPval, size=PROPval)
            combs = [value[1][i] for i in index]
            comb_list.append([combs, value[0]])
        PROPval = np.min([PROP,len(value[1])])
        d_candidates = list(np.zeros((PROPval,N),dtype=int))
        for i,d_cand in enumerate(d_candidates):
            for comb in comb_list:
                PROPval = np.min([PROP,len(comb[0])])
                d_cand[comb[1]] = comb[0][np.random.randint(PROPval)]
        votes = []
        for group_winner in group_winners:
            value = agents[group_winner]
            vote = []
            utility = []
            u_alpha = ALPHA*sum([fs[f][tuple(d[
                                i_mat[f]])] for f in value[0]]) / len(value[0])
            u_beta = BETA * F[tuple(d)]
            u = u_alpha + u_beta
            for d_cand in d_candidates:
                iep_alpha = ALPHA*sum([fs[f][tuple(d_cand[
                    i_mat[f]])] for f in value[0]]) / len(value[0])
                iep_beta = BETA * F[tuple(d_cand)]
                i_ep_good = iep_alpha + iep_beta
                error = np.random.normal(loc=0.0, scale=0.1, size=None)*i_ep_good
                while error > 0.1 or error < -0.1:
                    error = np.random.normal(loc=0.0, scale=0.1, size=None)*i_ep_good
                i_ep = i_ep_good + error
                utility.append(i_ep)
            for ut in utility:
                 if ut > u:
                     vote.append(1)
                 else:
                     vote.append (0)
            votes.append(vote)
        votes_a = [item[0] for item in votes]
        if len(votes[0]) == 2:
            votes_b = [item[1] for item in votes]
            votes = [votes_a,votes_b]
        else:
            votes = [votes_a]
        for i,v in enumerate(votes):
            if sum(v)==3:
                d = d_candidates[i]
                break
        return d

# This function determines the strategy that the coalition follows at every t

# 4. INDIVIDUAL LEARNING

def learning(agents, P, Q, comb_4, ALPHA, BETA, d, i_mat, fs, F, t):
    for agent, value in agents.items():
        if (np.random.rand() < P) and len(value[1]) < len(comb_4):
            know = value[1]
            know_idx = [nkp.bin2dec(i) for i in know]
            u_comb_4_idx = list(set(range(len(comb_4))) - set(know_idx))
            beliefs = [value[2][i] for i in u_comb_4_idx]
            probs=[x/(x+y) for x, y in beliefs]
            probs = np.array(probs)/sum(probs)
            vals = [comb_4[i] for i in u_comb_4_idx]
            know = [tuple(x) for x in know]
            # main lottery
            val_idx = np.random.choice(len(vals) , p=probs)
            val = vals[val_idx]
            value[4][val_idx] = t
            value_1 = value[1]
            agents[agent] = [value[0], np.append(value_1, [val], axis=0), value[2], value[3],value[4]]
        if (np.random.rand() < Q) and (len(value[1]) > 1):
            value_1 = value[1].copy()
            know = value[1]
            know_idx = [nkp.bin2dec(i) for i in know]
            beliefs = [value[3][i] for i in know_idx]
            probs=[x/(x+y) for x, y in beliefs]
            probs = np.array(probs)/sum(probs)
            # main lottery
            forget_index = np.random.choice(len(know), p = probs)
            value_1 = np.delete(value_1, forget_index, axis=0)
            agents[agent] = [value[0], value_1, value[2], value[3], value[4]]
    return agents

#  This function corresponds to the learning process.

def update(group_winners, utility_T, d, t, agents):
    agents2 = agents.copy()
    for i,j in enumerate(group_winners):
        impr = utility_T[t][i]-utility_T[t-1][i]
        d_sub = nkp.bin2dec([d[z] for z in agents2[j][0]])
        tmp_p = agents2[j][2][d_sub].copy()
        tmp_q = agents2[j][3][d_sub].copy()
        if impr < 0:
            tmp_p[1] += 1
            tmp_q[0] += 1
        if impr >= 0:
            tmp_p[0] += 1
            tmp_q[1] += 1
        agents2[j][2][d_sub] = tmp_p
        agents2[j][3][d_sub] = tmp_q
    return agents2

def decay(agents, t):
    agents2 = agents.copy()
    for agent, value in agents2.items():
        # t_temp = [t - i for i in value[4]]
        know = value[1]
        know_idx = [nkp.bin2dec(i) for i in know]
        for idx in know_idx:
            new_value = value[3][idx].copy()
            new_value[0] = new_value[0] + delta
            value[3][idx] = new_value
    return agents2

# These functions update the agent's beliefs

# 5. SEQUENCE OF EVENTS

def ind_utility(d, fs, i_mat, ALPHA, BETA, F):
    utilities = []
    combi = [np.arange(0,4),np.arange(4,8),np.arange(8,12)]
    for part in combi:
        u_alpha = ALPHA*sum([fs[j][tuple(d[
            i_mat[j]])] for j in part]) / len(part)
        u_beta = BETA * F[tuple(d)]
        utility = u_alpha + u_beta
        utilities.append(utility)
    return utilities

# This function calculates the utility for each agent in the group.

def get_repetitions(mc_strategies):
    F_fs, i_mat = lg.get_Fs(1, N, K, TYPE)
    # The first argument is the number of landscapes
    F, fs = F_fs[0], F_fs[1]
    max_perf = max(F.values())
    # min_perf = min(F.values())
    # print(max_perf)
    # print(min_perf)
    d, d_L1, d_L2, d_L3, valid_comb_4 = \
        get_decisions()
#    print(d)
#    print(F[tuple(d)])
    group_count_1, group_count_2, group_count_3, agents = assign_groups(
            valid_comb_4)
    stop_count = 0
    while (group_count_1 == 0) or (group_count_2 == 0) or (group_count_3 == 0):
        group_count_1, group_count_2, group_count_3, agents = assign_groups(
                valid_comb_4)
        stop_count += 1
        if stop_count > 100:
            print("trigger")
            break
    t0_ut = ind_utility(d, fs, i_mat, ALPHA, BETA, F)
    strategies = [[d, F[tuple(d)]]]
    utility_T = [t0_ut]
    for t in range(T-1):
        if tau >= 1:
            if t % tau == 0:
                group_winners = get_coalition(F, fs, i_mat, d, agents)
        elif tau == 0:
            if t == 0:
                group_winners = get_coalition(F, fs, i_mat, d, agents)
        d = get_strategy(
                group_winners, agents, d, ALPHA, BETA, fs, i_mat, F, COORD, utility_T, t)
        strategies.append([d, F[tuple(d)]])
        utilities = ind_utility(d, fs, i_mat, ALPHA, BETA, F)
        utility_T.append(utilities)
        agents = update(group_winners, utility_T, d, t, agents)
        agents = decay(agents, t)
        # print(agents)
        agents = learning(agents, P, Q, comb_4, ALPHA, BETA, d, i_mat, fs, F, t)
    utilities = np.array(utility_T)
    ut_1 = utilities[:, 0]
    ut_2 = utilities[:, 1]
    ut_3 = utilities[:, 2]
    mc_strategies[mc, i, :] = [z[1] for z in strategies]
    performance[mc, i, :] = np.divide(mc_strategies[mc, i], max_perf)
    mc_utility_1[mc, i, :] = np.divide(ut_1, max_perf) # NEED TO CALCULATE MAX_UT
    mc_utility_2[mc, i, :] = np.divide(ut_2, max_perf) # NEED TO CALCULATE MAX_UT
    mc_utility_3[mc, i, :] = np.divide(ut_3, max_perf) # NEED TO CALCULATE MAX_UT
    mc_utilities = [mc_utility_1, mc_utility_2, mc_utility_3]
    return F, fs, d, performance, mc_utility_1, mc_utility_2, mc_utility_3, \
        agents, mc_utilities

# This function determines whether team formation occurs or not.

groups = (L1, L2, L3)
comb_4 = [*itertools.product((0, 1), repeat=4)]
mc_strategies = np.zeros((MC, len(TAU), T))
mc_utility_1 = np.zeros((MC, len(TAU), T))
mc_utility_2 = np.zeros((MC, len(TAU), T))
mc_utility_3 = np.zeros((MC, len(TAU), T))
performance = np.zeros((MC, len(TAU), T))
for mc in tqdm(range(MC)):
    for i, tau in enumerate(TAU):
        F, fs, d, performance, mc_utility_1, mc_utility_2, mc_utility_3,\
            agents, mc_utilities = get_repetitions(mc_strategies)
    mean_utility_1 = np.mean(mc_utility_1, 0)
    std_utility_1 = np.std(mc_utility_1, 0)
    mean_utility_2 = np.mean(mc_utility_2, 0)
    std_utility_2 = np.std(mc_utility_2, 0)
    mean_utility_3 = np.mean(mc_utility_3, 0)
    std_utility_3 = np.std(mc_utility_3, 0)
    mean_performance = np.mean(performance, 0)
    std_performance = np.std(performance, 0)
    av_perf = np.mean(mean_performance,axis=1)
np.savetxt(f"mean performance_{K}_{P}_{TYPE}_{COORD}.csv", mean_performance,fmt="%10.5f")

labels = ["Initial self-organization, τ=1", "Moderate self-organization, τ=20",
          "High self-organization, τ=200"]
linestyles = ['-', '--', '-.', ':']
marker = ["^","o","s"]
marktime = [[0,10,20,30,40,50,60,70,80,90,100],
            [5,15,25,35,45,55,65,75,85,95],
            [2,12,22,32,42,52,62,72,82,92]]
plt.figure(dpi=300)
style.use("seaborn-paper")
for i in range(len(TAU)):
    marker_locations = list(range(5*i,100,20))
    plt.plot(mean_performance[i], label=labels[i], ls=linestyles[i],
              marker = marker[i], markevery=marker_locations, markersize=12, color="black")
    plt.xticks(fontsize="large")
    plt.yticks(fontsize="large")
    plt.legend(fontsize="x-large")
    plt.fill_between(range(len(mean_performance[i])), (
        mean_performance[i] - 3.3*std_performance[i]/np.sqrt(MC)), (
            mean_performance[i] + 3.3*std_performance[i]/np.sqrt(MC)),
            color="black", alpha=0.2, edgecolor ="black", ls=":")
    plt.ylim(0.59, 1.01)
plt.title("Mean performance",fontsize="x-large")
plt.savefig('performance.pdf')
plt.show()
